poj1417 带权并查集 + 背包 + 记录路径

True Liars

Time Limit: 1000MS   Memory Limit: 10000K
Total Submissions: 2713   Accepted: 868

Description

After having drifted about in a small boat for a couple of days, Akira Crusoe Maeda was finally cast ashore on a foggy island. Though he was exhausted and despaired, he was still fortunate to remember a legend of the foggy island, which he had heard from patriarchs in his childhood. This must be the island in the legend. In the legend, two tribes have inhabited the island, one is divine and the other is devilish, once members of the divine tribe bless you, your future is bright and promising, and your soul will eventually go to Heaven, in contrast, once members of the devilish tribe curse you, your future is bleak and hopeless, and your soul will eventually fall down to Hell.

In order to prevent the worst-case scenario, Akira should distinguish the devilish from the divine. But how? They looked exactly alike and he could not distinguish one from the other solely by their appearances. He still had his last hope, however. The members of the divine tribe are truth-tellers, that is, they always tell the truth and those of the devilish tribe are liars, that is, they always tell a lie.

He asked some of them whether or not some are divine. They knew one another very much and always responded to him "faithfully" according to their individual natures (i.e., they always tell the truth or always a lie). He did not dare to ask any other forms of questions, since the legend says that a devilish member would curse a person forever when he did not like the question. He had another piece of useful informationf the legend tells the populations of both tribes. These numbers in the legend are trustworthy since everyone living on this island is immortal and none have ever been born at least these millennia.

You are a good computer programmer and so requested to help Akira by writing a program that classifies the inhabitants according to their answers to his inquiries.

Input

The input consists of multiple data sets, each in the following format :

n p1 p2 
xl yl a1 
x2 y2 a2 
... 
xi yi ai 
... 
xn yn an

The first line has three non-negative integers n, p1, and p2. n is the number of questions Akira asked. pl and p2 are the populations of the divine and devilish tribes, respectively, in the legend. Each of the following n lines has two integers xi, yi and one word ai. xi and yi are the identification numbers of inhabitants, each of which is between 1 and p1 + p2, inclusive. ai is either yes, if the inhabitant xi said that the inhabitant yi was a member of the divine tribe, or no, otherwise. Note that xi and yi can be the same number since "are you a member of the divine tribe?" is a valid question. Note also that two lines may have the same x‘s and y‘s since Akira was very upset and might have asked the same question to the same one more than once.

You may assume that n is less than 1000 and that p1 and p2 are less than 300. A line with three zeros, i.e., 0 0 0, represents the end of the input. You can assume that each data set is consistent and no contradictory answers are included.

Output

For each data set, if it includes sufficient information to classify all the inhabitants, print the identification numbers of all the divine ones in ascending order, one in a line. In addition, following the output numbers, print end in a line. Otherwise, i.e., if a given data set does not include sufficient information to identify all the divine members, print no in a line.

Sample Input

2 1 1
1 2 no
2 1 no
3 2 1
1 1 yes
2 2 yes
3 3 yes
2 2 1
1 2 yes
2 3 no
5 4 3
1 2 yes
1 3 no
4 5 yes
5 6 yes
6 7 no
0 0 0

Sample Output

no
no
1
2
end
3
4
5
6
end

题意: 有n个人,p1个好人p2个坏人。那么如果一个人说另一个人是好人,那么如果这个人是好人,说明 对方确实是好人,如果这个是坏人,说明这句话是假的,对方也是坏人。

如果一个人说另一个人是坏人,那么如果这个人是好人,说明对方是坏人,如果这个是坏人,说明 对方是好人。

也就是如果条件是yes说明这两个是相同集合的,否则是两个不同的集合。这里就可以用带权并查集处理。然后就是现在有k个集合了,每个集合中有坏人和好人,怎么组合才能满足要求。这时候就可以用背包来处理。dp[i][j]表示第i个集合后是否有j个人。dp[k][p1] = 1表示存在且唯一,dp[k][p1] = 0 表示不存在,dp[k][p1]>1表示多个。

然后关键在于怎么输出所有满足的人。这时候就可以在背包的时候记录路径,记录当前满足的状态是上面哪一个状态推过来的。

#include<set>
#include<map>
#include<queue>
#include<stack>
#include<cmath>
#include<string>
#include<time.h>
#include<vector>
#include<cstdio>
#include<cstring>
#include<iostream>
#include<algorithm>
#define INF 1000000001
#define ll long long
#define lson l,m,rt<<1
#define rson m+1,r,rt<<1|1
using namespace std;
const int MAXN = 1010;
int pa[MAXN],n,p1,p2,rel[MAXN],vis[MAXN];
vector<int>b[MAXN][2];
int a[MAXN][2],dp[MAXN][MAXN],pre[MAXN][MAXN];
void Init()
{
    for(int i = 0; i <= p1 + p2; i++){
        pa[i] = i;
        b[i][0].clear();
        b[i][1].clear();
        a[i][0] = 0;
        a[i][1] = 0;
    }
    memset(rel,0,sizeof(rel));
}
int find(int x)
{
    if(x != pa[x]){
        int fx = find(pa[x]);
        rel[x] = (rel[x] + rel[pa[x]]) % 2;
        pa[x] = fx;
    }
    return pa[x];
}
int main()
{
    while(~scanf("%d%d%d",&n,&p1,&p2)){
        if(!n && !p1 && !p2)break;
        Init();
        int x,y,z;
        char s[10];
        for(int i = 0; i < n; i++){
            scanf("%d %d %s",&x,&y,s);
            if(s[0] == ‘y‘){
                z = 0;
            }
            else {
                z = 1;
            }
            int fx = find(x);
            int fy = find(y);
            if(fx != fy){
                pa[fx] = fy;
                rel[fx] = (2 - rel[x] + z + rel[y]) % 2;
            }
        }
        memset(vis,0,sizeof(vis));
        int cnt = 1;
        for(int i = 1; i <= p1 + p2; i++){
            if(!vis[i]){
                int tp = find(i);
                for(int j = i; j <= p1 + p2; j++){
                    int fp = find(j);
                    if(fp == tp){
                        vis[j] = 1;
                        b[cnt][rel[j]].push_back(j);
                        a[cnt][rel[j]] ++;
                    }
                }
                //cout<<a[cnt][0]<<‘ ‘<<a[cnt][1]<<endl;
                cnt ++;
            }
        }
        memset(vis,0,sizeof(vis));
        memset(dp,0,sizeof(dp));
        dp[0][0] = 1;
        for(int i = 1; i < cnt; i++){
            for(int j = p1; j >= 0; j--){
                if(j - a[i][0] >= 0 && dp[i-1][j - a[i][0]]){
                    dp[i][j] += dp[i-1][j-a[i][0]];
                    pre[i][j] = j - a[i][0];
                }
                if(j - a[i][1] >= 0 && dp[i-1][j - a[i][1]]){
                    dp[i][j] += dp[i-1][j-a[i][1]];
                    pre[i][j] = j - a[i][1];
                }
            }
        }
        if(dp[cnt-1][p1] != 1){
            printf("no\n");
        }
        else {
            vector<int>ans;
            int l = p1;
            for(int i = cnt - 1; i >= 1; i--){
                int tp = l - pre[i][l];
                if(tp == a[i][0]){
                    for(int j = 0; j < b[i][0].size(); j++){
                        ans.push_back(b[i][0][j]);
                    }
                }
                else {
                    for(int j = 0; j < b[i][1].size(); j++){
                        ans.push_back(b[i][1][j]);
                    }
                }
                l = pre[i][l];
            }
            sort(ans.begin(),ans.end());
            for(int i = 0; i < ans.size(); i++){
                printf("%d\n",ans[i]);
            }
            printf("end\n");
        }
    }
    return 0;
}
时间: 2024-11-03 11:56:36

poj1417 带权并查集 + 背包 + 记录路径的相关文章

poj1417 带权并查集+0/1背包

题意:有一个岛上住着一些神和魔,并且已知神和魔的数量,现在已知神总是说真话,魔总是说假话,有 n 个询问,问某个神或魔(身份未知),问题是问某个是神还是魔,根据他们的回答,问是否能够确定哪些是神哪些是魔. 对于这些问题,我们只需要发现,如果回答对方是魔,那么即可以判断出这两个不是同一种族,而如果回答对方是神,那么说明这两个是同一种族,那么就可以用带权并查集合并这些神和魔,然后记录两种分别多少个,这样当所有询问都处理完时我们就可以得到一系列的集合,每个集合分别有它的两个种族的人数,但是此时对于每个

总结一下我理解的带权并查集

总结一下我理解的带权并查集 与普通并查集的区别:普通的并查集仅仅记录的是集合的关系,这个关系无非是同属一个集合或者是不在一个集合,而带权并查集是记录集合内元素的关系,而这个关系被带上了一个权值表示集合内元素之间关系的区别,例如食物链这道题,权值为0表示和根节点是同类,权值为1表示吃根节点... 用向量法来表示带权并查集 查询是否在同一个集合,或者同一个集合内的元素如何表示他们之间的关系 ??? 每个元素带一个权值用rank表示 如上图,用向量法表示则是a->root+a->b=b->ro

并查集练习2(带权并查集)

明天旅游去爬山逛庙玩,今天练一天然后早早睡觉啦~ poj1703 Find them, Catch them (带权并查集) 1 #include<cstdio> 2 const int N=1e5+1; 3 int f[N]; 4 int r[N];//表示与父节点的关系,0同类,1不同类 5 int n; 6 void init(){ 7 for(int i=1;i<=n;++i){ 8 f[i]=i; r[i]=0; 9 } 10 } 11 int fin(int x){ 12 i

[NOIP摸你赛]Hzwer的陨石(带权并查集)

题目描述: 经过不懈的努力,Hzwer召唤了很多陨石.已知Hzwer的地图上共有n个区域,且一开始的时候第i个陨石掉在了第i个区域.有电力喷射背包的ndsf很自豪,他认为搬陨石很容易,所以他将一些区域的陨石全搬到了另外一些区域. 在ndsf愉快的搬运过程中,Hzwer想知道一些陨石的信息.对于Hzwer询问的每个陨石i,你必须告诉他,在当前这个时候,i号陨石在所在区域x.x区域共有的陨石数y.以及i号陨石被搬运的次数z. 输入描述: 输入的第一行是一个正整数T.表示有多少组输入数据. 接下来共有

并查集2——带权并查集

路径压缩 前面的并查集的复杂度实际上有些极端情况会很慢.比如树的结构正好是一条链,那么最坏情况下,每次查询的复杂度达到了 O(n). 路径压缩 的思想是,我们只关心每个结点的父结点,而并不太关心树的真正的结构. 这样我们在一次查询的时候,可以把查询路径上的所有结点的 father[i] 都赋值成为根结点.只需要在我们之前的查询函数上面很小的改动. int get(int x) { if (father[x] == x) { // x 结点就是根结点 return x; } return fath

hdu3635 Dragon Balls(带权并查集)

1 /* 2 题意:有N个城市, 每一个城市都有一个龙珠(编号与城市的编号相同),有两个操作 3 T A ,B 将标号为A龙珠所在城市的所有的龙珠移动到B龙珠所在城市中! 4 5 思路:并查集 (压缩路径的时候将龙珠移动的次数进行更新) 6 */ 7 #include<iostream> 8 #include<cstring> 9 #include<cstdio> 10 #include<algorithm> 11 #define M 10005 12 us

POJ 1703 Find them, Catch them(带权并查集)

传送门 Find them, Catch them Time Limit: 1000MS   Memory Limit: 10000K Total Submissions: 42463   Accepted: 13065 Description The police office in Tadu City decides to say ends to the chaos, as launch actions to root up the TWO gangs in the city, Gang D

【BZOJ 3376】[Usaco2004 Open]Cube Stacking 方块游戏 带权并查集

这道题一开始以为是平衡树结果发现复杂度过不去,然后发现我们一直合并而且只是记录到最低的距离,那么就是带权并查集了,带权并查集的权一般是到根的距离,因为不算根要好打,不过还有一些其他的,具体的具体打. #include <cstdio> #include <cstring> const int N=30050; int h[N],f[N],size[N]; char s[2]; inline int find(int x){ if(f[x]==x)return x; int temp

poj1182食物链,经典带权并查集

动物王国中有三类动物A,B,C,这三类动物的食物链构成了有趣的环形.A吃B, B吃C,C吃A. 现有N个动物,以1-N编号.每个动物都是A,B,C中的一种,但是我们并不知道它到底是哪一种. 有人用两种说法对这N个动物所构成的食物链关系进行描述: 第一种说法是"1 X Y",表示X和Y是同类. 第二种说法是"2 X Y",表示X吃Y. 此人对N个动物,用上述两种说法,一句接一句地说出K句话,这K句话有的是真的,有的是假的.当一句话满足下列三条之一时,这句话就是假话,否